/* ---------------------------------------------------------- 
%   (C)1993 Institute for New Generation Computer Technology 
%       (Read COPYRIGHT for detailed information.) 
%   (C)1996, 1997, 1998, 1999 Japan Information Processing Development Center
%       (Read COPYRIGHT-JIPDEC for detailed information.)
----------------------------------------------------------- */

#ifndef _KLIC_ALLOC_H_
#define _KLIC_ALLOC_H_

extern q* klic_interrupt();

/* Reverse allocation from "heaptop" */

#define revalloc(s, words, maketype) \
do{ \
  heapbottom -= (words); \
  (s) = maketype(heapbottom); \
\
  real_heaplimit -= (words); \
  if(heaplimit != 0) \
    heaplimit = (interrupt_off ? real_heaplimit : 0); \
}while(0)

#define heapalloc(s, words, maketype) \
  revalloc((s), (words), maketype)

#endif /* _KLIC_ALLOC_H_ */
